typedef struct __TRIANGLE {
 GLuint id;           // odkaz na poziciu trojuholnika v spojitom poli

 GLfloat x1,y1,z1;    // 3D suradnice 3 vrcholov
 GLfloat x2,y2,z2;
 GLfloat x3,y3,z3;

 GLfloat xn1,yn1,zn1; // 3D normaly pre 3 vrcholy
 GLfloat xn2,yn2,zn2;
 GLfloat xn3,yn3,zn3;

 GLfloat xt1,yt1;     // 2D koordinaty textur v 3 vrcholoch
 GLfloat xt2,yt2;
 GLfloat xt3,yt3;

 __TRIANGLE *next; // odkaz na dalsi trojuholnik v zozname
} _TRIANGLE;

// trieda premennych a funkcii pre pracu s trojuholnikom
class glTriangle {
public:
 glTriangle();
 virtual ~glTriangle();

 // pridanie trojuholnika do zoznamu
 int triangle_add(GLfloat a1,GLfloat a2,GLfloat a3,
                  GLfloat b1,GLfloat b2,GLfloat b3,
                  GLfloat c1,GLfloat c2,GLfloat c3,
                  GLfloat d1,GLfloat d2,
                  GLfloat e1,GLfloat e2,
                  GLfloat f1,GLfloat f2);

 // ziskanie odkazu na zoznam trojuholnikov
 _TRIANGLE *GetTriangles(void);
 // vyhladenie normal, q-pocet troj. v smere x, w-pocet troj. v smere y
 int SmoothNormals(GLuint q,GLuint w);
 // vykreslenie normal
 void DrawNormals();

 GLuint all_tris_count; // celkovy pocet trojuholnikov v zozname

 // spojite pole trojuholnikov
 GLfloat *triangle_array;
 // vytvorenie spojiteho pola trojuholnikov zo zoznamu
 int create_triangle_array(void);
 // ziskanie odkazu na spojite pole trojuholnikov
 GLfloat *GetTriangleArray(void);
private:
 GLuint a; // pomocna premenna

 _TRIANGLE *m_first_triangle,*m_last_triangle; // prvy, posledny trojuholnik
 _TRIANGLE *m_t;                               // pomocna premenna

 GLfloat xx,yy,zz; // pomocne premenne

 // vypocet a normalizacia normal
 void NormaliseNormal(GLfloat n1,GLfloat n2,GLfloat n3,
                      GLfloat *a,GLfloat *b,GLfloat *c);
 void CalcNormal(GLfloat p1,GLfloat p2,GLfloat p3,
                 GLfloat q1,GLfloat q2,GLfloat q3,
                 GLfloat r1,GLfloat r2,GLfloat r3,
                 GLfloat *a,GLfloat *b,GLfloat *c);
};

